The same mechanisms are used for normal and fallback images. 
Hence drop the FALLBACK_ prefix

Signed-off-by: Stefan Reinauer <stepan@coreboot.org>

Index: src/Kconfig
===================================================================
--- src/Kconfig	(revision 6203)
+++ src/Kconfig	(working copy)
@@ -357,7 +357,7 @@
 
 endchoice
 
-config FALLBACK_PAYLOAD_FILE
+config PAYLOAD_FILE
 	string "Payload path and filename"
 	depends on PAYLOAD_ELF
 	default "payload.elf"
@@ -390,14 +390,14 @@
 	  You will be able to specify the location and file name of the
 	  image later.
 
-config FALLBACK_VGA_BIOS_FILE
+config VGA_BIOS_FILE
 	string "VGA BIOS path and filename"
 	depends on VGA_BIOS
 	default "vgabios.bin"
 	help
 	  The path and filename of the file to use as VGA BIOS.
 
-config FALLBACK_VGA_BIOS_ID
+config VGA_BIOS_ID
 	string "VGA device PCI IDs"
 	depends on VGA_BIOS
 	default "1106,3230"
@@ -421,7 +421,7 @@
 	  You will be able to specify the location and file name of the
 	  image later.
 
-config FALLBACK_MBI_FILE
+config MBI_FILE
 	string "Intel MBI path and filename"
 	depends on INTEL_MBI
 	default "mbi.bin"
@@ -441,7 +441,7 @@
 	  This option shows a graphical bootsplash screen. The grapics are
 	  loaded from the CBFS file bootsplash.jpg.
 
-config FALLBACK_BOOTSPLASH_FILE
+config BOOTSPLASH_FILE
 	string "Bootsplash path and filename"
 	depends on BOOTSPLASH
 	default "bootsplash.jpg"
Index: src/mainboard/getac/p470/Kconfig
===================================================================
--- src/mainboard/getac/p470/Kconfig	(revision 6203)
+++ src/mainboard/getac/p470/Kconfig	(working copy)
@@ -76,7 +76,7 @@
 	int
 	default 2
 
-config FALLBACK_VGA_BIOS_FILE
+config VGA_BIOS_FILE
 	string
 	default "getac-pci8086,27a2.rom"
 
Index: src/mainboard/kontron/986lcd-m/Kconfig
===================================================================
--- src/mainboard/kontron/986lcd-m/Kconfig	(revision 6203)
+++ src/mainboard/kontron/986lcd-m/Kconfig	(working copy)
@@ -54,7 +54,7 @@
 	int
 	default 2
 
-config FALLBACK_VGA_BIOS_FILE
+config VGA_BIOS_FILE
 	string
 	default "amipci_01.20"
 
Index: src/mainboard/iei/kino-780am2-fam10/Kconfig
===================================================================
--- src/mainboard/iei/kino-780am2-fam10/Kconfig	(revision 6203)
+++ src/mainboard/iei/kino-780am2-fam10/Kconfig	(working copy)
@@ -91,7 +91,7 @@
 	hex
 	default 0x200000
 
-config FALLBACK_VGA_BIOS_ID
+config VGA_BIOS_ID
 	string
 	default "1002,9615"
 
Index: src/mainboard/via/pc2500e/Kconfig
===================================================================
--- src/mainboard/via/pc2500e/Kconfig	(revision 6203)
+++ src/mainboard/via/pc2500e/Kconfig	(working copy)
@@ -34,11 +34,11 @@
 	hex
 	default 0xaa51
 
-config FALLBACK_VGA_BIOS_FILE
+config VGA_BIOS_FILE
 	string
 	default "M14CRT.ROM"
 
-config FALLBACK_VGA_BIOS_ID
+config VGA_BIOS_ID
 	string
 	default "1106,3344"
 
Index: src/mainboard/ibase/mb899/Kconfig
===================================================================
--- src/mainboard/ibase/mb899/Kconfig	(revision 6203)
+++ src/mainboard/ibase/mb899/Kconfig	(working copy)
@@ -53,7 +53,7 @@
 	int
 	default 2
 
-config FALLBACK_VGA_BIOS_FILE
+config VGA_BIOS_FILE
 	string
 	default "amipci_01.20"
 
Index: src/mainboard/msi/ms6178/Kconfig
===================================================================
--- src/mainboard/msi/ms6178/Kconfig	(revision 6203)
+++ src/mainboard/msi/ms6178/Kconfig	(working copy)
@@ -42,8 +42,8 @@
 	int
 	default 4
 
-# No need to override the chipset FALLBACK_VGA_BIOS_ID.
-config FALLBACK_VGA_BIOS_FILE
+# No need to override the chipset VGA_BIOS_ID.
+config VGA_BIOS_FILE
 	string
 	default "i810.vga"
 
Index: src/northbridge/via/cn700/Kconfig
===================================================================
--- src/northbridge/via/cn700/Kconfig	(revision 6203)
+++ src/northbridge/via/cn700/Kconfig	(working copy)
@@ -2,11 +2,6 @@
 	bool
 	select HAVE_DEBUG_RAM_SETUP
 
-config FALLBACK_SIZE
-	int
-	default 0
-	depends on NORTHBRIDGE_VIA_CN700
-
 # TODO: Values are from the CX700 datasheet, not sure if this matches CN700.
 # TODO: What should be the per-chipset default value here?
 choice
Index: src/northbridge/intel/i945/Kconfig
===================================================================
--- src/northbridge/intel/i945/Kconfig	(revision 6203)
+++ src/northbridge/intel/i945/Kconfig	(working copy)
@@ -27,7 +27,7 @@
 
 if NORTHBRIDGE_INTEL_I945GC || NORTHBRIDGE_INTEL_I945GM
 
-config FALLBACK_VGA_BIOS_ID
+config VGA_BIOS_ID
 	string
 	default "8086,27a2"
 
Index: src/northbridge/intel/i82810/Kconfig
===================================================================
--- src/northbridge/intel/i82810/Kconfig	(revision 6203)
+++ src/northbridge/intel/i82810/Kconfig	(working copy)
@@ -42,7 +42,7 @@
 	default 1   if I810_VIDEO_MB_1MB
 	depends on NORTHBRIDGE_INTEL_I82810
 
-config FALLBACK_VGA_BIOS_ID
+config VGA_BIOS_ID
 	string
 	default "8086,7121"
 	depends on NORTHBRIDGE_INTEL_I82810
Index: src/northbridge/intel/sch/Kconfig
===================================================================
--- src/northbridge/intel/sch/Kconfig	(revision 6203)
+++ src/northbridge/intel/sch/Kconfig	(working copy)
@@ -23,7 +23,7 @@
 
 if NORTHBRIDGE_INTEL_SCH
 
-config FALLBACK_VGA_BIOS_ID
+config VGA_BIOS_ID
 	string
 	default "8086,8108"
 endif
Index: src/arch/x86/Makefile.inc
===================================================================
--- src/arch/x86/Makefile.inc	(revision 6203)
+++ src/arch/x86/Makefile.inc	(working copy)
@@ -35,16 +35,16 @@
 # Build the final rom image
 COREBOOT_ROM_DEPENDENCIES:=
 ifneq ($(CONFIG_PAYLOAD_NONE),y)
-COREBOOT_ROM_DEPENDENCIES+=$(CONFIG_FALLBACK_PAYLOAD_FILE)
+COREBOOT_ROM_DEPENDENCIES+=$(CONFIG_PAYLOAD_FILE)
 endif
 ifeq ($(CONFIG_VGA_BIOS),y)
-COREBOOT_ROM_DEPENDENCIES+=$(CONFIG_FALLBACK_VGA_BIOS_FILE)
+COREBOOT_ROM_DEPENDENCIES+=$(CONFIG_VGA_BIOS_FILE)
 endif
 ifeq ($(CONFIG_INTEL_MBI),y)
-COREBOOT_ROM_DEPENDENCIES+=$(CONFIG_FALLBACK_MBI_FILE)
+COREBOOT_ROM_DEPENDENCIES+=$(CONFIG_MBI_FILE)
 endif
 ifeq ($(CONFIG_BOOTSPLASH),y)
-COREBOOT_ROM_DEPENDENCIES+=$(CONFIG_FALLBACK_BOOTSPLASH_FILE)
+COREBOOT_ROM_DEPENDENCIES+=$(CONFIG_BOOTSPLASH_FILE)
 endif
 ifeq ($(CONFIG_AP_CODE_IN_CAR),y)
 COREBOOT_ROM_DEPENDENCIES+=$(obj)/coreboot_ap
@@ -81,20 +81,20 @@
 ifeq ($(CONFIG_PAYLOAD_NONE),y)
 	@printf "    PAYLOAD    \e[1;31mnone (as specified by user)\e[0m\n"
 else
-	@printf "    PAYLOAD    $(CONFIG_FALLBACK_PAYLOAD_FILE) (compression: $(CBFS_PAYLOAD_COMPRESS_NAME))\n"
-	$(CBFSTOOL) $@.tmp add-payload $(CONFIG_FALLBACK_PAYLOAD_FILE) $(CONFIG_CBFS_PREFIX)/payload $(CBFS_PAYLOAD_COMPRESS_FLAG)
+	@printf "    PAYLOAD    $(CONFIG_PAYLOAD_FILE) (compression: $(CBFS_PAYLOAD_COMPRESS_NAME))\n"
+	$(CBFSTOOL) $@.tmp add-payload $(CONFIG_PAYLOAD_FILE) $(CONFIG_CBFS_PREFIX)/payload $(CBFS_PAYLOAD_COMPRESS_FLAG)
 endif
 ifeq ($(CONFIG_VGA_BIOS),y)
-	@printf "    VGABIOS    $(CONFIG_FALLBACK_VGA_BIOS_FILE) $(CONFIG_FALLBACK_VGA_BIOS_ID)\n"
-	$(CBFSTOOL) $@.tmp add $(CONFIG_FALLBACK_VGA_BIOS_FILE) "pci$(CONFIG_FALLBACK_VGA_BIOS_ID).rom" optionrom
+	@printf "    VGABIOS    $(CONFIG_VGA_BIOS_FILE) $(CONFIG_VGA_BIOS_ID)\n"
+	$(CBFSTOOL) $@.tmp add $(CONFIG_VGA_BIOS_FILE) "pci$(CONFIG_VGA_BIOS_ID).rom" optionrom
 endif
 ifeq ($(CONFIG_INTEL_MBI),y)
-	@printf "    MBI        $(CONFIG_FALLBACK_MBI_FILE)\n"
-	$(CBFSTOOL) $@.tmp add $(CONFIG_FALLBACK_MBI_FILE) mbi.bin mbi
+	@printf "    MBI        $(CONFIG_MBI_FILE)\n"
+	$(CBFSTOOL) $@.tmp add $(CONFIG_MBI_FILE) mbi.bin mbi
 endif
 ifeq ($(CONFIG_BOOTSPLASH),y)
-	@printf "    BOOTSPLASH $(CONFIG_FALLBACK_BOOTSPLASH_FILE)\n"
-	$(CBFSTOOL) $@.tmp add $(CONFIG_FALLBACK_BOOTSPLASH_FILE) bootsplash.jpg bootsplash
+	@printf "    BOOTSPLASH $(CONFIG_BOOTSPLASH_FILE)\n"
+	$(CBFSTOOL) $@.tmp add $(CONFIG_BOOTSPLASH_FILE) bootsplash.jpg bootsplash
 endif
 ifeq ($(CONFIG_GEODE_VSA_FILE),y)
 	@printf "    VSA        $(CONFIG_VSA_FILENAME)\n"
Index: util/abuild/abuild
===================================================================
--- util/abuild/abuild	(revision 6203)
+++ util/abuild/abuild	(working copy)
@@ -176,7 +176,7 @@
 		if [ "$PAYLOAD" != "/dev/null" ]; then
 			echo "# CONFIG_PAYLOAD_NONE is not set" >> ${build_dir}/config.build
 			echo "CONFIG_PAYLOAD_ELF=y" >> ${build_dir}/config.build
-			echo "CONFIG_FALLBACK_PAYLOAD_FILE=\"$PAYLOAD\"" >> ${build_dir}/config.build
+			echo "CONFIG_PAYLOAD_FILE=\"$PAYLOAD\"" >> ${build_dir}/config.build
 		fi
 
 		if [ "$loglevel" != "default" ]; then